//----------------------------------------------------------------------------//
//                                         888                                //
//                                         888                                //
//                                         888                                //
//                         8888b.  888d888 888  888                           //
//                            `88b 888P'   888 .88P                           //
//                        .d888888 888     888888K                            //
//                        888  888 888     888 `88b                           //
//                        `Y888888 888     888  888                           //
//                                                                            //
//                                                                            //
//  File      : math_utils.mjs                                                //
//  Project   : lissajous                                                     //
//  Date      : 15 Dec, 21                                                    //
//  License   : GPLv3                                                         //
//  Author    : stdmatt <stdmatt@pixelwizards.io>                             //
//  Copyright : stdmatt - 2021                                                //
//                                                                            //
//  Description :                                                             //
//                                                                            //
//---------------------------------------------------------------------------~//

//----------------------------------------------------------------------------//
// Vec2                                                                       //
//----------------------------------------------------------------------------//
//------------------------------------------------------------------------------
export class Vec2
    extends PIXI.Point
{
    // Empty...
    constructor(x, y)
    {
        super(x || 0, y || 0);
    }
}

//----------------------------------------------------------------------------//
// Size                                                                       //
//----------------------------------------------------------------------------//
//------------------------------------------------------------------------------
export class Size
{
    //--------------------------------------------------------------------------
    constructor(w, h)
    {
        this.width  = w || 0;
        this.height = h || 0;
    }
}

//----------------------------------------------------------------------------//
// Rect                                                                       //
//----------------------------------------------------------------------------//
//------------------------------------------------------------------------------
export class Rect
{
    //--------------------------------------------------------------------------
    constructor(x, y, w, h)
    {
        this.x      = x || 0;
        this.y      = y || 0;
        this.width  = w || 0;
        this.height = h || 0;
    }
}


//----------------------------------------------------------------------------//
// Math_Utils                                                                 //
//----------------------------------------------------------------------------//
//------------------------------------------------------------------------------
export class Math_Utils
{
    //--------------------------------------------------------------------------
    static HALF_PI   = Math.PI * 0.5;
    static PI        = Math.PI * 1.0;
    static TWO_PI    = Math.PI * 2.0;
    static THREE_PI  = Math.PI * 3.0;
    static FOUR_PI   = Math.PI * 4.0;

    //--------------------------------------------------------------------------
    static to_int(a) { return Math.trunc(a); }

    static int_mod(a, b) { return Math_Utils.to_int(a) % Math_Utils.to_int(b); }

    //--------------------------------------------------------------------------
    static to_radians(degrees) { return degrees * Math.PI / 180.0; }
    static to_degrees(radians) { return radians * 180.0 / Math.PI; }

    //--------------------------------------------------------------------------
    static angle_from_xy(x, y)
    {
        let theta = Math_Utils.to_degrees(Math.atan2(y, x));
        if(theta < 0) {
            theta += 360;
        }
        return theta;
    }


    //--------------------------------------------------------------------------
    static make_size(w, h)       { return new Size(w, h);       }
    static make_rect(x, y, w, h) { return new Rect(x, y, w, h); }
    static make_vec2(x, y)       { return new Vec2(x, y);       }
}
